#include <iostream>
#include <SDL.h>
#include "cursormanager.hpp"

int main(int argc, char** argv)
{
    SDL_Event event;
    bool quit = false;
    int fps=0,now,last;
    int x,y;
    SDL_Rect rect = {0,0,0,0};
    
    if (SDL_Init(SDL_INIT_VIDEO) < 0)
    {
        std::cerr << "Erreur  l'initialisation de la SDL : " << SDL_GetError() << std::endl;
        return EXIT_FAILURE;
    }

    SDL_Surface *ecran = SDL_SetVideoMode(800, 600, 32, SDL_HWSURFACE);
    if (ecran == NULL)
    {
        std::cerr << "SDL - Impossible d'activer le mode graphique : " << SDL_GetError() << std::endl;
        SDL_Quit();
        return EXIT_FAILURE;
    }

    SDL_WM_SetCaption("Test des curseurs SDL", NULL);

    // Pour le calcul du FPS
    last = SDL_GetTicks()/1000;

    // Pour la souris
    SDL_Surface *mouse = SDL_LoadBMP("cursor.bmp");
    if(mouse == NULL)
    {
        std::cerr << "SDL - Impossible de charger l'image pour la souris" << std::endl;
        SDL_Quit();
        return EXIT_FAILURE;
    }

    // On enleve la souris actuelle
    SDL_ShowCursor(0);
    
    do
    {
        // On met une couleur de fond
        SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 60, 0, 0));

        /* Le code dessin se trouverait ici... */

        // On recupere la position de la souris
	SDL_GetMouseState(&x,&y);

	//On met a jour la structure rect
	rect.x = x;
	rect.y = y;

	//On met notre image de souris
	SDL_BlitSurface(mouse,NULL,ecran,&rect);
        SDL_Flip(ecran);

        while(SDL_PollEvent(&event))
        {
            switch (event.type)
            {
                case SDL_KEYDOWN :
                {
                    quit = true;
                    break;
                }
                case SDL_QUIT :
                {
                    quit = true;
                    break;
                }
                default :
                {
                    break;
                }
            }
        }

	// Pour le calcul du FPS...
	now = SDL_GetTicks()/1000;
	fps++;
	if(now!=last)
	 {
	 std::cerr << "Fps: " << fps/(now-last) << std::endl;
	 last = now;
	 fps = 0;
	 }
    }
    while (!quit);


    SDL_FreeSurface(mouse);
    SDL_Quit();

    (void) argc;
    (void) argv;
    return EXIT_SUCCESS;
}
